' Spielfeld-Editor Version 0.04
' editiert Laser 3.04 und Bankraub 2.00
'
' benoetigt zusaetzlich die Funktionen
'   function editor_frage(byval frage as string) as byte
'   sub editor_leseopt(byval x as ubyte, byval y as ubyte)
'   function editor_leveltest as integer
'   sub editor_meldung(byval text as string)
'   sub editor_setzeopt(byval x as ubyte, byval y as ubyte, byval wert as byte)
'   sub editor_setoptionen(byval set as string)
'   sub testspiel
' und greift auf weitere Funktionen des Spiels zu:
'   function bildschirm_speichern as any ptr
'   sub bildschirm_zuruecksetzen(speicher as any ptr)
'   sub ladeinfo(set as string, typ as ubyte, kommentar as string, autor as string, version as ushort)
'   sub speichereinfo(set as string, typ as ubyte, kommentar as string, autor as string, version as ushort)
'   sub laden(set as string, nr as ubyte)
'   sub speichern(set as string, nr as ubyte = 0)
'   sub loeschen(set as string, nr as ubyte)
'   sub verschieben(set as string, nr1 as ubyte, nr2 as ubyte)
'   sub reorganisation(set as string)
'   sub stein(x as ubyte, y as ubyte, nr as ubyte, extra as ubyte)
'
' benoetigt zusaetzlich die Variablen (shared)
'   EDITOR_STEINBREITE, EDITOR_STEINHOEHE, EDITOR_LEVELBREITE, EDITOR_LEVELHOEHE
'   EDITOR_LVLBPLUS, EDITOR_LVLHPLUS, EDITOR_LEVELPFAD, EDITOR_EBENEN
'   EDITOR_ZEITMIN, EDITOR_ZEITMAX, EDITOR_ZEITSTEP, EDITOR_WINTITEL
'   editorfeld(1 to EDITOR_LEVELBREITE+EDITOR_LVLBPLUS, 1 to EDITOR_LEVELHOEHE+EDITOR_LVLHPLUS, 0 to EDITOR_EBENEN-1)
' und greift auf weitere Variablen des Spiels zu (shared):
'   _MODUS_, levanz, zeit, feld(x, y), typ, kommentar, autor, version
'
' Diese Angaben erfolgen ohne Garantie auf Vollstaendigkeit.

type TypUndo
  as ubyte x, y, nr, ebene
  declare constructor(x as ubyte = 0, y as ubyte = 0, nr as ubyte = 0, ebene as ubyte = 0)
end type

declare sub editor(byref levname as string = "", byref levnr as ushort = 1)
declare sub editor_neu
declare sub editor_zeit(byval x as ubyte, byval y as ubyte)
declare function inputt(z as ubyte, byval s as ubyte, txt as string, muster as string, byref ret as string) as string
declare function mustertest(byval wert as ubyte, byval muster as ubyte) as byte

constructor TypUndo(x as ubyte = 0, y as ubyte = 0, nr as ubyte = 0, ebene as ubyte = 0)
  this.x = x
  this.y = y
  this.nr = nr
  this.ebene = ebene
end constructor

sub editor(byref levname as string = "", byref levnr as ushort = 1)
  dim as ubyte ebene
  windowtitle EDITOR_WINTITEL
  _MODUS_ = 1
  dim as integer mx, my, mb, mx2, my2
  dim as ubyte x, y, x2, y2, cursorx, cursory, undostart, undopos, undoende
  dim as string taste, eingabe, eingabe2
  dim speicher as any ptr, geaendert as byte, undogeschoben as byte
  dim as TypUndo editor_undo(0 to 255)
  do
    if right(levname, 4) = ".lev" then levname = left(levname, len(levname)-4)
    do
      cls
      levname = inputt(2, 2, "Gib ein Levelset ein: ", "dddddddddddddd", levname)
      if dir(EDITOR_LEVELPFAD & levname & "*.lev")<>"" or levname="" or levname=chr(27) then exit do
      eingabe = inputt(4, 2, "Das Levelset existiert nicht. Willst du es neu anlegen? ", "?", "")
      if lcase(eingabe) = "j" or lcase(eingabe) = "y" then
        levanz = 1
        editor_neu
        ebene = 0
        speichereinfo levname & ".lev", 1, "neues Spiel", "unbekannt", 0
        speichern levname & ".lev", 1
        reorganisation(levname & ".lev")
        exit do
      end if
    loop
    levname = dir(EDITOR_LEVELPFAD & levname & "*.lev")
    if levname = "" then exit sub

    cls
    ladeinfo levname, typ, kommentar, autor, version
    if levnr > levanz then levnr = 1
    laden levname, levnr
    geaendert = 0
    undostart = 0
    undoende = 0
    undopos = 0
    undogeschoben = 0
    windowtitle EDITOR_WINTITEL & " - " & levname & ", Level " & levnr & " von " & levanz
    for i as ubyte = 1 to EDITOR_LEVELBREITE + EDITOR_LVLBPLUS
      for k as ubyte = 1 to EDITOR_LEVELHOEHE + EDITOR_LVLHPLUS
        stein i, k, editorfeld(i, k, 0), 0
      next
    next
    cursorx = 1
    cursory = 1
    line (0, 0)-step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
    locate 1, 66
    print "Zeit: " & zeit & "    "

    do
      getmouse mx, my,, mb
      taste = inkey
      if taste = chr(27) or taste = chr(255) & "k" then
        if geaendert then
          if editor_frage("Das Level wurde geaendert.\nWollen Sie trotzdem beenden?") = 0 then continue do
        end if
        exit do
      end if
      x = int(mx/EDITOR_STEINBREITE) + 1
      y = int(my/EDITOR_STEINHOEHE) + 1
      if mb = 1 then ' linke Maustaste: Stein auswaehlen bzw. setzen
        if y < 4 and (editorfeld(x, y, ebene) <> 0 or (x = 1 and y = 1)) then
          stein cursorx, cursory, editorfeld(cursorx, cursory, ebene), ebene
          cursorx = x
          cursory = y
          line ((cursorx-1)*EDITOR_STEINBREITE, (cursory-1)*EDITOR_STEINHOEHE) _
               -step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
        elseif x > EDITOR_LVLBPLUS and x <= EDITOR_LVLBPLUS+EDITOR_LEVELBREITE and _
               y > EDITOR_LVLHPLUS and y <= EDITOR_LVLHPLUS+EDITOR_LEVELHOEHE  and _
               cursory < 4 then
          if editorfeld(x, y, ebene) <> editorfeld(cursorx, cursory, ebene) then
            editor_undo(undopos) = TypUndo(x, y, editorfeld(x, y, ebene), ebene)
            undopos += 1
            undoende = undopos
            if undopos = undostart then undostart += 1 : undogeschoben = -1
            editorfeld(x, y, ebene) = editorfeld(cursorx, cursory, ebene)
            stein x, y, editorfeld(x, y, ebene), ebene
            geaendert = -1
          end if
          editor_zeit(cursorx, cursory)
        end if
      end if

      if mb = 2 and x > EDITOR_LVLBPLUS and x <= EDITOR_LVLBPLUS+EDITOR_LEVELBREITE and _
                    y > EDITOR_LVLHPLUS and y <= EDITOR_LVLHPLUS+EDITOR_LEVELHOEHE  then
        ' rechte Maustate: Optionen einstellen
        stein cursorx, cursory, editorfeld(cursorx, cursory, ebene), ebene
        cursorx = x
        cursory = y
        line ((cursorx-1)*EDITOR_STEINBREITE, (cursory-1)*EDITOR_STEINHOEHE) _
             -step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
        editor_leseopt(cursorx, cursory)
        do
          getmouse mx2, my2,, mb
          sleep 1
        loop until mb = 0
      end if

      if mb = 4 and cursory < 4 then ' mittlere Maustaste: Bloecke fuellen
        if x <= EDITOR_LVLBPLUS then x = EDITOR_LVLBPLUS + 1
        if x > EDITOR_LVLBPLUS+EDITOR_LEVELBREITE then x = EDITOR_LVLBPLUS+EDITOR_LEVELBREITE
        if y <= EDITOR_LVLHPLUS then y = EDITOR_LVLHPLUS + 1
        if y > EDITOR_LVLHPLUS+EDITOR_LEVELHOEHE then y = EDITOR_LVLHPLUS+EDITOR_LEVELHOEHE
        do
          getmouse mx2, my2,, mb
        loop until mb = 0
        x2 = int(mx2/EDITOR_STEINBREITE)+1
        y2 = int(my2/EDITOR_STEINHOEHE)+1
        if x2 <= EDITOR_LVLBPLUS then x2 = EDITOR_LVLBPLUS + 1
        if x2 > EDITOR_LVLBPLUS+EDITOR_LEVELBREITE then x2 = EDITOR_LVLBPLUS+EDITOR_LEVELBREITE
        if y2 <= EDITOR_LVLHPLUS then y2 = EDITOR_LVLHPLUS + 1
        if y2 > EDITOR_LVLHPLUS+EDITOR_LEVELHOEHE then y2 = EDITOR_LVLHPLUS+EDITOR_LEVELHOEHE
        if x > x2 then swap x, x2
        if y > y2 then swap y, y2
        for i as ubyte = x to x2
          for k as ubyte = y to y2
            if editorfeld(i, k, ebene) <> editorfeld(cursorx, cursory, ebene) then
              editor_undo(undopos) = TypUndo(i, k, editorfeld(i, k, ebene), ebene)
              undopos += 1
              undoende = undopos
              if undopos = undostart then undostart += 1 : undogeschoben = -1
              editorfeld(i, k, ebene) = editorfeld(cursorx, cursory, ebene)
              stein i, k, editorfeld(i, k, ebene), ebene
              geaendert = -1
            end if
            if inkey = chr(255)+"k" then taste = chr(255)+"k" : exit do
          next
        next
      end if

      select case taste
        case "h", "H"
          speicher = bildschirm_speichern
          cls
          print
          print " Tastenbelegung:"
          print
          print " h: Hilfe aufrufen"
          print " l: Level aus dem Set laden"
          print " s: Level im Set speichern"
          print " i: Level importieren (*.export)"
          print " e: Level exportieren (*.export)"
          print " k: Level aus dem Set loeschen"
          print " m: Level im Set verschieben"
          print " u: undo - letzter Schritt rueckgaengig"
          print " U: redo - letztes Undo wiederherstellen"
          print
          print " n: Spielfeld leeren"
          print " o: Set-Einstellungen setzen"
          print " t: Testspiel"
          print " r: Set reorganisieren"
          print
          print " +/-: Zeit bzw. Feldoptionen aendern"
          if EDITOR_EBENEN > 1 then print " 1-" & EDITOR_EBENEN & ": Ebene wechseln"
          print " Pfeiltasten: Cursor bewegen"
          print
          print " esc: Levelset verlassen"
          getkey
          cls
          bildschirm_zuruecksetzen(speicher)
        case "r", "R"
          if editor_frage("Levelset reorganisieren?") then reorganisation(levname)
        case "t", "T"
          if editor_leveltest then testspiel
        case "n", "N"
          if geaendert then
            if editor_frage("Das Level wurde geaendert.\nWollen Sie jetzt trotzdem\nein neues Level erstellen?") = 0 then
              continue do
            end if
          end if
          levnr = levanz + 1
          geaendert = 0
          undostart = 0
          undoende = 0
          undopos = 0
          undogeschoben = 0
          windowtitle EDITOR_WINTITEL & " - " & levname & ", Level " & levnr & " von " & levanz
          editor_neu
          ebene = 0
          if cursory > 3 then
            cursorx = 1
            cursory = 1
          end if
          line ((cursorx-1)*EDITOR_STEINBREITE, (cursory-1)*EDITOR_STEINHOEHE) _
               -step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
        case "l", "L"
          if geaendert then
            if editor_frage("Das Level wurde geaendert.\nWollen Sie trotzdem neu laden?") = 0 then
              continue do
            end if
          end if
          eingabe = inputt(1, 66, "Laden  ", "000", "")
          if eingabe = chr(255) + "k" then taste=chr(255)+"k" : exit sub
          if val(eingabe) > 0 and val(eingabe) <= levanz then
            levnr = val(eingabe)
            laden levname, levnr
            geaendert = 0
            undostart = 0
            undoende = 0
            undopos = 0
            undogeschoben = 0
            for i as ubyte = 1 to EDITOR_LEVELBREITE + EDITOR_LVLBPLUS
              editorfeld(i, 1, ebene) = editorfeld(i, 1, ebene)
              editorfeld(i, 2, ebene) = editorfeld(i, 2, ebene)
              for k as ubyte = 1 to EDITOR_LEVELHOEHE + EDITOR_LVLHPLUS
                stein i, k, editorfeld(i, k, ebene), ebene
              next
            next
            if cursory > 3 then
              cursorx = 1
              cursory = 1
            end if
            line ((cursorx-1)*EDITOR_STEINBREITE, (cursory-1)*EDITOR_STEINHOEHE) _
                 -step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
          end if
          editor_zeit(cursorx, cursory)
          windowtitle EDITOR_WINTITEL & " - " & levname & ", Level " & levnr & " von " & levanz
        case "s", "S"
          if editor_leveltest then
            eingabe = inputt(1, 66, "Speichern ", "000", str(levnr))
            if eingabe = chr(255) + "k" then taste = chr(255)+"k" : exit sub
            if val(eingabe) > 0 and val(eingabe) <= levanz + 1 then
              levnr = val(eingabe)
              speichern levname, levnr
              geaendert = 0
            end if
            editor_zeit(cursorx, cursory)
            windowtitle EDITOR_WINTITEL & " - " & levname & ", Level " & levnr & " von " & levanz
          end if
        case "i", "I"
          if geaendert then
            if editor_frage("Das Level wurde geaendert.\nWollen Sie trotzdem neu laden?") = 0 then
              continue do
            end if
          end if
          eingabe = inputt(1, 64, "Import ", "dddddddd", "")
          if eingabe = chr(255) + "k" then taste = chr(255)+"k" : exit sub
          if eingabe <> "" and eingabe <> chr(27) then
            laden eingabe & ".export"
            geaendert = 0
            undostart = 0
            undoende = 0
            undopos = 0
            undogeschoben = 0
            locate 1, 64
            print string(15, 32)
            for i as ubyte = 1 tO EDITOR_LEVELBREITE + EDITOR_LVLBPLUS
              editorfeld(i, 1, ebene) = editorfeld(i, 1, ebene)
              editorfeld(i, 2, ebene) = editorfeld(i, 2, ebene)
              for k as ubyte = 1 tO EDITOR_LEVELHOEHE + EDITOR_LVLHPLUS
                stein i, k, editorfeld(i, k, ebene), ebene
              next
            next
            line (0, 0)-step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
            if cursory > 3 then
              cursorx = 1
              cursory = 1
            end if
            line ((cursorx-1)*EDITOR_STEINBREITE, (cursory-1)*EDITOR_STEINHOEHE) _
                 -step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
          end if
          editor_zeit(cursorx, cursory)
          windowtitle EDITOR_WINTITEL & " - " & levname & ", " & levanz & " Level"
        case "e", "E"
          editor_leveltest
          eingabe = inputt(1, 64, "Export ", "dddddddd", "")
          if eingabe = chr(255) + "k" then taste = chr(255)+"k" : exit sub
          if eingabe <> "" and eingabe <> chr(27) then
            speichern eingabe & ".export"
            locate 1, 64
            print string(15, 32)
          end if
          editor_zeit(cursorx, cursory)
        case "k", "K"
          eingabe = inputt(1, 66, "Loeschen ", "000", "")
          if eingabe = chr(255) + "k" then taste = chr(255)+"k" : exit sub
          if val(eingabe) > 0 and val(eingabe) <= levanz then loeschen levname, val(eingabe)
          editor_zeit(cursorx, cursory)
          windowtitle EDITOR_WINTITEL & " - " & levname & ", Level " & levnr & " von " & levanz
        case "m", "M"
          eingabe = inputt(1, 66, "Schieben ", "000", "")
          if eingabe = chr(255) + "k" then taste = chr(255)+"k" : exit sub
          if val(eingabe) > 0 and val(eingabe) <= levanz then
            eingabe2 = inputt(1, 66, eingabe & " nach ", "000", "")
            if eingabe2 = chr(255) + "k" then taste = chr(255)+"k" : exit sub
            if val(eingabe) > 0 and val(eingabe) <= levanz then
              verschieben levname, val(eingabe), val(eingabe2)
            end if
          end if
          editor_zeit(cursorx, cursory)
        case "o", "O"
          editor_setoptionen(levname)
        case "u"
          if undopos <> undostart then
            undopos -= 1
            locate 1, 1
            with editor_undo(undopos)
              dim as integer temp = editorfeld(.x, .y, ebene)
              editorfeld(.x, .y, ebene) = .nr
              .nr = temp
              stein .x, .y, editorfeld(.x, .y, ebene), ebene
            end with
            if undopos = undostart and undogeschoben = 0 then geaendert = 0
          end if
        case "U"
          if undopos <> undoende then
            locate 1, 1
            with editor_undo(undopos)
              dim as integer temp = editorfeld(.x, .y, ebene)
              editorfeld(.x, .y, ebene) = .nr
              .nr = temp
              stein .x, .y, editorfeld(.x, .y, ebene), ebene
            end with
            undopos += 1
            geaendert = 1
          end if
        case "+"
          if cursory < 4 then
            if zeit < EDITOR_ZEITMAX then
              zeit += EDITOR_ZEITSTEP
              if cursory < 4 then
                locate 1, 66
                print "Zeit: " & zeit & "    "
              else
                editor_leseopt(cursorx, cursory)
              end if
            end if
          else
            editor_setzeopt(cursorx, cursory, 1)
            line ((cursorx-1)*EDITOR_STEINBREITE, (cursory-1)*EDITOR_STEINHOEHE) _
                 -step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
          end if
        case "-"
          if cursory < 4 then
            if zeit > EDITOR_ZEITMIN Then
              zeit -= EDITOR_ZEITSTEP
              locate 1, 66
              print "Zeit: " & zeit & "    "
            end if
          else
            editor_setzeopt(cursorx, cursory, -1)
            line ((cursorx-1)*EDITOR_STEINBREITE, (cursory-1)*EDITOR_STEINHOEHE) _
                 -step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
          end if
        case chr(255, 75)
          if cursory < 4 then
            stein cursorx, cursory, editorfeld(cursorx, cursory, ebene), ebene
            cursorx -= 1
            if cursorx = 0 then
              cursorx = EDITOR_LEVELBREITE
              do while editorfeld(cursorx, cursory, ebene) = 0 and cursorx > 1
                cursorx -= 1
              loop
            end if
            line ((cursorx-1)*EDITOR_STEINBREITE, (cursory-1)*EDITOR_STEINHOEHE) _
                 -step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
          end if
        case chr(255, 77)
          if cursory < 4 then
            stein cursorx, cursory, editorfeld(cursorx, cursory, ebene), ebene
            cursorx += 1
            if editorfeld(cursorx, cursory, ebene) = 0 then cursorx = 1
            line ((cursorx-1)*EDITOR_STEINBREITE, (cursory-1)*EDITOR_STEINHOEHE) _
                 -step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
          end if
        case chr(255, 72)
          if cursory > 1 and cursory < 4 then
            stein cursorx, cursory, editorfeld(cursorx, cursory, ebene), ebene
            if editorfeld(cursorx, cursory-1, ebene) <> 0 then cursory -= 1
            line ((cursorx-1)*EDITOR_STEINBREITE, (cursory-1)*EDITOR_STEINHOEHE) _
                 -step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
          end if
        case chr(255, 80)
          if cursory < 3 then
            stein cursorx, cursory, editorfeld(cursorx, cursory, ebene), ebene
            if editorfeld(cursorx, cursory+1, ebene) <> 0 then cursory += 1
            line ((cursorx-1)*EDITOR_STEINBREITE, (cursory-1)*EDITOR_STEINHOEHE) _
                 -step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
          end if
        case "1" to "9"
          if val(taste) <> ebene+1 and val(taste) <= EDITOR_EBENEN then
            print taste
            ebene = val(taste) - 1
            for i as ubyte = 1 to EDITOR_LVLBPLUS + EDITOR_LEVELBREITE
              for k as ubyte = 1 to EDITOR_LVLHPLUS + EDITOR_LEVELHOEHE
                stein i, k, editorfeld(i, k, ebene), ebene
              next
            next
          end if
      end select
      sleep 1
    loop
  loop until taste = chr(255) & "k"
  _MODUS_ = 0
end sub

sub editor_neu
  ' initiiert ein leeres Level
  for i as ubyte = EDITOR_LVLBPLUS + 1 to EDITOR_LVLBPLUS + EDITOR_LEVELBREITE
    for k as ubyte = EDITOR_LVLHPLUS + 1 to EDITOR_LVLHPLUS + EDITOR_LEVELHOEHE
      for e as ubyte = 0 to EDITOR_EBENEN - 1
        editorfeld(i, k, e) = 0
      next
      stein i, k, 0, 0
    next
  next
  for i as ubyte = 1 to EDITOR_LVLBPLUS + EDITOR_LEVELBREITE
    for k as ubyte = 1 to EDITOR_LVLHPLUS + EDITOR_LEVELHOEHE
      stein i, k, editorfeld(i, k, 0), 0
    next
  next
end sub

sub editor_zeit(byval x as ubyte, byval y as ubyte)
  if y < 4 then
    locate 1, 66
    print "Zeit: " & zeit & "  "
  else
    editor_leseopt(x, y)
  end if
end sub

function inputt(z as ubyte, byval s as ubyte, txt as string, muster as string, byref vorgabe as string) as string
  ' formatierte Eingabe an der Stelle z/s
  ' txt: Ausgabetext; muster: Eingabemuster; ret: Eingabe (kann vorbelegt werden)
  ' Rueckgabewert: Eingabe oder chr(27) oder chr(255)+"k"
  ' ACHTUNG: Es findet keine Sicherheitspruefung statt.
  dim as string taste, eingabe, m = muster & "$"
  eingabe = left(vorgabe, len(muster))
  dim as ubyte position = len(eingabe)
  locate z, s
  print txt & vorgabe & string(len(muster)-len(vorgabe), "_");
  s += len(txt)
  do
    taste = inkey
    if mustertest(asc(taste), muster[position]) then
      'locate z, s + position
      locate z, s + position
      print taste;
      position += 1
      eingabe &= taste
    end if
    if asc(taste) = 8 and position > 0 then
      position -= 1
      locate z, s + position
      print "_";
      eingabe = left(eingabe, position)
    end if
    sleep 1
  loop until taste=chr(13) or taste=chr(27) or taste=chr(255)+"k"
  locate z, s - len(txt)
  print string(len(txt & muster), 32)
  if taste=chr(13) then return eingabe
  return taste
end function

function mustertest(byval wert as ubyte, byval muster as ubyte) as byte
  ' testet, ob wert auf das Muster muster passt
  ' unterstuetzt werden: 0 (Zahl), a/A (Buchstabe), d (Zahl/Buchstabe/_/-), * (ASCII), ? (j/y/n)
  dim as ubyte art
  select case wert
    case 48 to 57                  ' Zahlen
      if muster=48 or muster=68 or muster=100 or muster=42 then return -1
    case 74, 78, 89, 106, 110, 121 ' Frage (j/y/n)
      if muster=63 or muster=65 or muster=97 or muster=68 or muster=100 or muster=42 then return -1
    case 65 to 90, 97 to 122       ' Buchstaben
      if muster=65 or muster=97 or muster=68 or muster=100 or muster=42 then return -1
    case 45, 95                    ' Unter- und Bindestrich
      if muster=68 or muster=100 or muster=42 then return -1
    case 32 to 126                 ' sonstige ASCII-Zeichen
      if muster=42 then return -1
  end select
  return 0
end function

